class VacationRentalsIcalAdapters::Registry
  attr_reader :adapters
  private     :adapters

  def initialize
    @adapters = []
  end

  def find_adapter(&block)
    adapters.find(adapter_not_found_proc, &block)
  end

  def register(adapter)
    adapters << adapter
  end

  private

  def adapter_not_found_proc
    -> { raise AdapterNotFoundError }
  end

  class AdapterNotFoundError < RuntimeError
    def message
      "Couldn't find adapter for given :body and :source, conversion to iCal format not possible."
    end
  end
end
